#-----------------------------------------------------------------------
# File    : hubness.mak
# Contents: build hubness program (on Windows systems)
# Author  : Christian Borgelt
# History : 2012.12.17 file created
#-----------------------------------------------------------------------
THISDIR  = ..\..\hubness\src
UTILDIR  = ..\..\util\src

CC       = cl.exe
DEFS     = /D WIN32 /D NDEBUG /D _CONSOLE /D _CRT_SECURE_NO_WARNINGS
CFLAGS   = /nologo /W3 /O2 /GS- $(DEFS) /c
INCS     = /I $(UTILDIR)

LD       = link.exe
LDFLAGS  = /nologo /subsystem:console /incremental:no
LIBS     = 

HDRS     = $(UTILDIR)\random.h
OBJS     = $(UTILDIR)\random.obj
PRGS     = hubness.exe

#-----------------------------------------------------------------------
# Build Programs
#-----------------------------------------------------------------------
all:          $(PRGS)

hubness.exe:  $(OBJS) hubness.obj hubness.mak
	$(LD) $(LDFLAGS) $(OBJS) $(LIBS) hubness.obj /out:$@

#-----------------------------------------------------------------------
# Main Programs
#-----------------------------------------------------------------------
hubness.obj:  $(HDRS) hubness.c hubness.mak
	$(CC) $(CFLAGS) $(INCS) hubness.c /Fo$@

#-----------------------------------------------------------------------
# External Modules
#-----------------------------------------------------------------------
$(UTILDIR)\random.obj:
	cd $(UTILDIR)
	$(MAKE) /f util.mak random.obj
	cd $(THISDIR)

#-----------------------------------------------------------------------
# Install
#-----------------------------------------------------------------------
install:
	-@copy hubness.exe ..\..\..\bin

#-----------------------------------------------------------------------
# Clean up
#-----------------------------------------------------------------------
localclean:
	-@erase /Q *~ *.obj *.idb *.pch $(PRGS)

clean:
	$(MAKE) /f hubness.mak localclean
	cd $(UTILDIR)
	$(MAKE) /f util.mak clean
	cd $(THISDIR)
